## sra-sdk 2.0.1

=== Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


#-------------------------------------------------------------------------------
# default
#
SUBDIRS = \
	libs \
	tools

default: $(SUBDIRS)

test: $(SUBDIRS)

$(SUBDIRS) test:
	@ $(MAKE) -C $@

.PHONY: default $(SUBDIRS) test

#-------------------------------------------------------------------------------
# static vs. dynamic
#
static:
	@ touch "$(CURDIR)/build/STATIC"

dynamic:
	@ rm -f "$(CURDIR)/build/STATIC"

.PHONY: static dynamic

#-------------------------------------------------------------------------------
# all
#
SUBDIRS_ALL = $(addsuffix _all,$(SUBDIRS))

all: $(SUBDIRS_ALL)

$(SUBDIRS_ALL):
	@ $(MAKE) -C $(subst _all,,$@) all

.PHONY: all $(SUBDIRS_ALL)

#-------------------------------------------------------------------------------
# std
#
SUBDIRS_STD = $(addsuffix _std,$(SUBDIRS))

std: $(SUBDIRS_STD)

$(SUBDIRS_STD):
	@ $(MAKE) -C $(subst _std,,$@) std

.PHONY: std $(SUBDIRS_STD)

#-------------------------------------------------------------------------------
# clean
#
SUBDIRS_CLEAN = $(addsuffix _clean,$(SUBDIRS_ALL))

clean: $(SUBDIRS_CLEAN)

$(SUBDIRS_CLEAN):
	@ $(MAKE) -C $(subst _all_clean,,$@) clean

.PHONY: clean $(SUBDIRS_CLEAN)


#-------------------------------------------------------------------------------
# pass-through targets
#
COMPILERS = GCC ICC VC++
ARCHITECTURES = i386 x86_64
CONFIG = debug profile release
PASSTHRUS = \
	out \
	CC $(COMPILERS) \
	$(ARCHITECTURES) \
	$(CONFIG)

$(PASSTHRUS):
	@ $(MAKE) TOP=$(CURDIR) -f build/Makefile.env $@

.PHONY: $(CONFIG) $(COMPILERS) out


#-------------------------------------------------------------------------------
# configuration help
#
help configure:
	@ echo "Before initial build, run 'make OUTDIR=<dir> out' from"
	@ echo "the project root to set the output directory of your builds."
	@ echo
	@ echo "To select a compiler, run 'make <comp>' where"
	@ echo "comp = { "$(COMPILERS)" }."
	@ echo
	@ echo "For hosts that support cross-compilation ( only Macintosh today ),"
	@ echo "you can run 'make <arch>' where arch = { "$(ARCHITECTURES)" }."
	@ echo
	@ echo "To set a build configuration, run 'make <config>' where"
	@ echo "config = { "$(CONFIG)" }."
	@ echo

.PHONY: help configure

=== libs/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


TOP ?= $(shell ../build/abspath.sh ..)
MODULE = libs

#-------------------------------------------------------------------------------
# default
#
SUBDIRS = \
	ext \
	klib \
	kproc \
	kfs \
	kxml \
	kfg \
	kapp \
	kdb \
	vdb \
	vxf \
	search \
	sra \
	sraxf

default: $(SUBDIRS)

$(SUBDIRS):
	@ $(MAKE) -C $@

.PHONY: default $(SUBDIRS)

#-------------------------------------------------------------------------------
# all
#
SUBDIRS_ALL = $(addsuffix _all,$(SUBDIRS))

all: $(SUBDIRS_ALL)

$(SUBDIRS_ALL):
	@ $(MAKE) -C $(subst _all,,$@) all

.PHONY: all $(SUBDIRS_ALL)

#-------------------------------------------------------------------------------
# std
#
SUBDIRS_STD = $(addsuffix _std,$(SUBDIRS))

std: $(SUBDIRS_STD)

$(SUBDIRS_STD):
	@ $(MAKE) -C $(subst _std,,$@) std

.PHONY: std $(SUBDIRS_STD)

#-------------------------------------------------------------------------------
# clean
#
SUBDIRS_CLEAN = $(addsuffix _clean,$(SUBDIRS))

clean: $(SUBDIRS_CLEAN)

$(SUBDIRS_CLEAN):
	@ $(MAKE) -C $(subst _clean,,$@) clean

.PHONY: clean $(SUBDIRS_CLEAN)


#-------------------------------------------------------------------------------
# tag
#
SUBDIRS_TAG = $(addsuffix _tag,$(SUBDIRS))

tag: $(SUBDIRS_TAG)

$(SUBDIRS_TAG):
	@ $(MAKE) -C $(subst _tag,,$@) tag

.PHONY: tag $(SUBDIRS_TAG)


#-------------------------------------------------------------------------------
# pass-through
#
out debug profile release GCC ICC VC++:
	@ $(MAKE) TOP=$(TOP) -f $(TOP)/build/Makefile.env $@

.PHONY: out debug profile release GCC ICC VC++

=== tools/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


TOP ?= $(shell ../build/abspath.sh ..)
MODULE = tools

#-------------------------------------------------------------------------------
# default
#
SUBDIRS = \
	util \
	kar \
	vdb-dump \
	sra-dump \
	sra-load \
	sra-stat \
	vdb-copy \
    sra-dbcc

default: $(SUBDIRS)

$(SUBDIRS):
	@ $(MAKE) -C $@

.PHONY: default $(SUBDIRS)

#-------------------------------------------------------------------------------
# all
#
SUBDIRS_ALL = $(addsuffix _all,$(SUBDIRS))

all: $(SUBDIRS_ALL)

$(SUBDIRS_ALL):
	@ $(MAKE) -C $(subst _all,,$@) all

.PHONY: all $(SUBDIRS_ALL)

#-------------------------------------------------------------------------------
# std
#
SUBDIRS_STD = $(addsuffix _std,$(SUBDIRS))

std: $(SUBDIRS_STD)

$(SUBDIRS_STD):
	@ $(MAKE) -C $(subst _std,,$@) std

.PHONY: std $(SUBDIRS_STD)

#-------------------------------------------------------------------------------
# clean
#
SUBDIRS_CLEAN = $(addsuffix _clean,$(SUBDIRS))

clean: $(SUBDIRS_CLEAN)

$(SUBDIRS_CLEAN):
	@ $(MAKE) -C $(subst _clean,,$@) clean

.PHONY: clean $(SUBDIRS_CLEAN)


#-------------------------------------------------------------------------------
# tag
#
SUBDIRS_TAG = $(addsuffix _tag,$(SUBDIRS))

tag: $(SUBDIRS_TAG)

$(SUBDIRS_TAG):
	@ $(MAKE) -C $(subst _tag,,$@) tag

.PHONY: tag $(SUBDIRS_TAG)


#-------------------------------------------------------------------------------
# pass-through
#
out debug profile release GCC ICC VC++:
	@ $(MAKE) TOP=$(TOP) -f $(TOP)/build/Makefile.env $@

.PHONY: out debug profile release GCC ICC VC++

=== libs/ext/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


TOP ?= $(shell ../../build/abspath.sh ../..)
MODULE = libs/ext

#-------------------------------------------------------------------------------
# default
#
SUBDIRS = \
	zlib \
	bzip2

default: $(SUBDIRS)

$(SUBDIRS):
	@ $(MAKE) -C $@

.PHONY: default $(SUBDIRS)

#-------------------------------------------------------------------------------
# all
#
SUBDIRS_ALL = $(addsuffix _all,$(SUBDIRS))

all: $(SUBDIRS_ALL)

$(SUBDIRS_ALL):
	@ $(MAKE) -C $(subst _all,,$@) all

.PHONY: all $(SUBDIRS_ALL)

#-------------------------------------------------------------------------------
# std
#
SUBDIRS_STD = $(addsuffix _std,$(SUBDIRS))

std: $(SUBDIRS_STD)

$(SUBDIRS_STD):
	@ $(MAKE) -C $(subst _std,,$@) std

.PHONY: std $(SUBDIRS_STD)

#-------------------------------------------------------------------------------
# clean
#
SUBDIRS_CLEAN = $(addsuffix _clean,$(SUBDIRS))

clean: $(SUBDIRS_CLEAN)

$(SUBDIRS_CLEAN):
	@ $(MAKE) -C $(subst _clean,,$@) clean

.PHONY: clean $(SUBDIRS_CLEAN)


#-------------------------------------------------------------------------------
# tag
#
SUBDIRS_TAG = $(addsuffix _tag,$(SUBDIRS))

tag: $(SUBDIRS_TAG)

$(SUBDIRS_TAG):
	@ $(MAKE) -C $(subst _tag,,$@) tag

.PHONY: tag $(SUBDIRS_TAG)


#-------------------------------------------------------------------------------
# pass-through
#
out debug profile release GCC ICC VC++:
	@ $(MAKE) TOP=$(TOP) -f $(TOP)/build/Makefile.env $@

.PHONY: out debug profile release GCC ICC VC++

=== libs/kapp/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: std

TOP ?= $(shell ../../build/abspath.sh ../..)
MODULE = libs/kapp

include $(TOP)/build/Makefile.env

INT_LIBS = \
	libkapp

EXT_LIBS = \

ALL_LIBS = \
	$(INT_LIBS) \
	$(EXT_LIBS)

#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(ILIBDIR)/$@

$(EXT_LIBS): makedirs
	@ $(MAKE_CMD) $(LIBDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS)) \
	$(addprefix $(LIBDIR)/,$(EXT_LIBS))

.PHONY: $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# tag
#
tag: \
	$(addsuffix _tag,$(ALL_LIBS))

.PHONY: tag $(addsuffix _tag,$(ALL_LIBS))


#-------------------------------------------------------------------------------
# OS specific application support
#
$(ILIBDIR)/libkapp: $(addprefix $(ILIBDIR)/libkapp.,$(LIBX))

KAPP_SRC = \
	main \
	args \
	sysmain

KAPP_OBJ = \
	$(addsuffix .$(OBJX),$(KAPP_SRC))

KAPP_LIB = \
	-dklib

$(ILIBDIR)/libkapp.$(LIBX): $(KAPP_OBJ)
	$(LD) --slib -o $@ $^ $(KAPP_LIB)

libkapp_tag:
	@ $(TOP)/build/tag-module.sh $(MODULE) libkapp $(KAPP_OBJ)

=== libs/kdb/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: std

TOP ?= $(shell ../../build/abspath.sh ../..)
MODULE = libs/kdb

INT_LIBS = \

EXT_LIBS = \
	libkdb \
	libwkdb

ALL_LIBS = \
	$(INT_LIBS) \
	$(EXT_LIBS)

include $(TOP)/build/Makefile.env

#-------------------------------------------------------------------------------
# outer targets
#
vers-includes: $(addsuffix .vers.h,$(ALL_LIBS))

all std: makedirs vers-includes
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs vers-includes
	@ $(MAKE_CMD) $(ILIBDIR)/$@

$(EXT_LIBS): makedirs vers-includes
	@ $(MAKE_CMD) $(LIBDIR)/$@

.PHONY: all std $(ALL_LIBS) $(ALL_DEFS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS)) \
	$(addprefix $(LIBDIR)/,$(EXT_LIBS))

.PHONY: $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# tag
#
tag: \
	$(addsuffix _tag,$(ALL_LIBS))

.PHONY: tag $(addsuffix _tag,$(ALL_LIBS))

#-------------------------------------------------------------------------------
# kdb
#
$(LIBDIR)/libkdb: $(addprefix $(LIBDIR)/libkdb.,$(LIBEXT))

KDB_CMN = \
	btree \
	dbmgr-cmn \
#	database-cmn

KDB_SRC = \
	$(KDB_CMN) \
	kdb \
	dbmgr \
	database \
	dbcc-cmn \
	table \
	table-cc \
	column \
	column-cc \
	coldata \
	colidx \
	colidx0 \
	colidx1 \
	colidx2 \
	idxblk \
	meta \
	index \
	idstats \
	trieidx-v1 \
	trieval-v1 \
	ptrieval-v1 \
	trieidx-v2 \
	trieval-v2 \
	ptrieval-v2 \
	u64idx-v3

KDB_OBJ = \
	$(addsuffix .$(LOBX),$(KDB_SRC))

KDB_LIB = \
	-dkfs \
	-dklib

$(LIBDIR)/libkdb.$(SHLX): $(KDB_OBJ)
	$(LD) --dlib --vers $(SRCDIR) -o $@ $^ $(KDB_LIB)

$(LIBDIR)/libkdb.$(LIBX): $(KDB_OBJ)
	$(LD) --slib --vers $(SRCDIR) -o $@ $^ $(KDB_LIB)

libkdb_tag:
	@ $(TOP)/build/tag-module.sh $(MODULE) libkdb $(KDB_OBJ)


#-------------------------------------------------------------------------------
# wkdb
#
$(LIBDIR)/libwkdb: $(addprefix $(LIBDIR)/libwkdb.,$(LIBEXT))

WKDB_SRC = \
	$(KDB_CMN) \
	wkdb \
	wdbmgr \
	wdatabase \
	wtable \
	wcolumn \
	wcoldata \
	wcolidx \
	wcolidx0 \
	wcolidx1 \
	wcolidx2 \
	idxblk \
	widxblk \
	wmeta \
	windex \
	wtrieidx-v1 \
	wtrieidx-v2 \
	wu64idx-v3

WKDB_OBJ = \
	$(addsuffix .$(LOBX),$(WKDB_SRC))

WKDB_LIB = \
	-dkfs \
	-dklib

$(LIBDIR)/libwkdb.$(SHLX): $(WKDB_OBJ)
	$(LD) --dlib --vers $(SRCDIR) -o $@ $^ $(WKDB_LIB)

$(LIBDIR)/libwkdb.$(LIBX): $(WKDB_OBJ)
	$(LD) --slib --vers $(SRCDIR) -o $@ $^ $(WKDB_LIB)

libwkdb_tag:
	@ $(TOP)/build/tag-module.sh $(MODULE) libwkdb $(WKDB_OBJ)

=== libs/kfg/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: all

TOP ?= $(shell ../../build/abspath.sh ../..)
MODULE = libs/kfg

INT_LIBS = \

EXT_LIBS = \
	libkfg

ALL_LIBS = \
	$(INT_LIBS) \
	$(EXT_LIBS)

include $(TOP)/build/Makefile.env

#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(ILIBDIR)/$@

$(EXT_LIBS): makedirs
	@ $(MAKE_CMD) $(LIBDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS)) \
	$(addprefix $(LIBDIR)/,$(EXT_LIBS))

.PHONY: $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# tag
#
tag: \
	$(addsuffix _tag,$(ALL_LIBS))

.PHONY: tag $(addsuffix _tag,$(ALL_LIBS))

#-------------------------------------------------------------------------------
# kfg
#
$(LIBDIR)/libkfg: $(NCBIDIR)/config.kfg $(addprefix $(LIBDIR)/libkfg.,$(LIBEXT))

$(NCBIDIR)/config.kfg: $(SRCDIR)/config.$(OS).kfg
	cp $^ $@

KFG_SRC = \
	config

KFG_OBJ = \
	$(addsuffix .$(LOBX),$(KFG_SRC))

KFG_LIB = \
	-dkfs \
	-dklib

$(LIBDIR)/libkfg.$(SHLX): $(KFG_OBJ)
	$(LD) --dlib --vers $(SRCDIR) -o $@ $^ $(KFG_LIB)

$(LIBDIR)/libkfg.$(LIBX): $(KFG_OBJ)
	$(LD) --slib --vers $(SRCDIR) -o $@ $^ $(KFG_LIB)

libkfg_tag:
	@ $(TOP)/build/tag-module.sh $(MODULE) libkfg $(KFG_OBJ)

=== libs/kfs/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: all

TOP ?= $(shell ../../build/abspath.sh ../..)
MODULE = libs/kfs

ifdef NCBI
INT_LIBS = \
	libkff
endif

EXT_LIBS = \
	libkfs

ALL_LIBS = \
	$(INT_LIBS) \
	$(EXT_LIBS)

include $(TOP)/build/Makefile.env

#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(ILIBDIR)/$@

$(EXT_LIBS): makedirs
	@ $(MAKE_CMD) $(LIBDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS)) \
	$(addprefix $(LIBDIR)/,$(EXT_LIBS))

.PHONY: $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# tag
#
tag: \
	$(addsuffix _tag,$(ALL_LIBS))

.PHONY: tag $(addsuffix _tag,$(ALL_LIBS))

#-------------------------------------------------------------------------------
# kfs
#
$(LIBDIR)/libkfs: $(addprefix $(LIBDIR)/libkfs.,$(LIBEXT))

KFS_SRC = \
	directory \
	arrayfile \
	file \
	sysdir \
	sysfile \
	sysmmap \
	sysdll \
	gzip \
	bzip \
	md5 \
	crc32 \
	arc \
	toc \
	tocentry \
	tocdir \
	tocfile \
	sra \
	tar \
	teefile \
	buffile \
	buffile-write \
	subfile \
	nullfile \
	countfile \
	dir_test \
	pagefile \
	pmem


KFS_OBJ = \
	$(addsuffix .$(LOBX),$(KFS_SRC))

KFS_LIB = \
	-dklib \
	-ddl \
	-dz \
	-dbz2

$(LIBDIR)/libkfs.$(SHLX): $(KFS_OBJ)
	$(LD) --dlib --vers $(SRCDIR) -o $@ $^ $(KFS_LIB)

$(LIBDIR)/libkfs.$(LIBX): $(KFS_OBJ)
	$(LD) --slib --vers $(SRCDIR) -o $@ $^ $(KFS_LIB)

libkfs_tag:
	@ $(TOP)/build/tag-module.sh $(MODULE) libkfs $(KFS_OBJ)


#-------------------------------------------------------------------------------
# kff
#
ifeq (linux,$(OS))
$(ILIBDIR)/libkff: $(addprefix $(ILIBDIR)/libkff.,$(ILIBEXT))
else
$(ILIBDIR)/libkff:
	@ echo "not building libkff on "$(OS)
endif

KFF_SRC = \
	fileformat \
	ffext \
	ffkey

ifneq (win,$(OS))
	KFF_SRC += ffmagic
endif

KFF_OBJ = \
	$(addsuffix .$(LOBX),$(KFF_SRC))

KFF_LIB = \
	-dklib 

ifneq (win,$(OS))
	KFF_LIB += -lmagic
endif

$(ILIBDIR)/libkff.$(SHLX): $(KFF_OBJ)
	$(LD) --dlib -o $@ $^ $(KFF_LIB)

$(ILIBDIR)/libkff.$(LIBX): $(KFF_OBJ)
	$(LD) --slib -o $@ $^ $(KFF_LIB)

libkff_tag:
	@ $(TOP)/build/tag-module.sh $(MODULE) libkff $(KFF_OBJ)

=== libs/klib/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: all

TOP ?= $(shell ../../build/abspath.sh ../..)
MODULE = libs/klib

INT_LIBS = \

EXT_LIBS = \
	libklib

ALL_LIBS = \
	$(INT_LIBS) \
	$(EXT_LIBS)

include $(TOP)/build/Makefile.env

#-------------------------------------------------------------------------------
# outer targets
#
vers-includes: $(addsuffix .vers.h,$(EXT_LIBS))

all std: makedirs vers-includes
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs vers-includes
	@ $(MAKE_CMD) $(ILIBDIR)/$@

$(EXT_LIBS): makedirs vers-includes
	@ $(MAKE_CMD) $(LIBDIR)/$@

.PHONY: vers-includes all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS)) \
	$(addprefix $(LIBDIR)/,$(EXT_LIBS))

.PHONY: $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# tag
#
tag: \
	$(addsuffix _tag,$(ALL_LIBS))

.PHONY: tag $(addsuffix _tag,$(ALL_LIBS))

#-------------------------------------------------------------------------------
# klib
#
$(LIBDIR)/libklib: $(addprefix $(LIBDIR)/libklib.,$(LIBEXT))

KLIB_SRC = \
	text \
	utf8 \
	iso8859 \
	iso8859-1 \
	cp1252 \
	token \
	symtab \
	container \
	vector \
	namelist \
	vector_namelist \
	trie \
	pbstree \
	pbstree-impl.nopt \
	pbstree-impl.swap.nopt \
	bstpersist.nopt \
	ptrie.nopt \
	ptpersist.nopt \
	crc32 \
	md5 \
	qsort \
	bsearch \
	pack \
	unpack \
	vlen-encode \
	data-buffer \
	refcount \
	printf \
	status-rc-strings \
	status-rc \
	syswriter \
	out \
	status \
	log \
	writer \
	syslog \
	rc-tbl \
	rc-idx-tbl

ifeq (win,$(OS))
	KLIB_SRC += sysalloc
endif

ifeq (dbg,$(BUILD))
	KLIB_SRC += debug
endif

KLIB_OBJ = \
	$(addsuffix .$(LOBX),$(KLIB_SRC))

KLIB_LIB = \

$(LIBDIR)/libklib.$(SHLX): $(KLIB_OBJ)
	$(LD) --dlib --vers $(SRCDIR) -o $@ $^ $(KLIB_LIB)

$(LIBDIR)/libklib.$(LIBX): $(KLIB_OBJ)
	$(LD) --slib --vers $(SRCDIR) -o $@ $^ $(KLIB_LIB)

libklib_tag:
	@ $(TOP)/build/tag-module.sh $(MODULE) libklib $(KLIB_OBJ)

=== libs/sra/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: std

TOP ?= $(shell ../../build/abspath.sh ../..)
MODULE = libs/sra

INT_LIBS = \

EXT_LIBS = \
	libsrapath \
	libsraschema \
	libwsraschema \
	libsradb \
	libwsradb \
	libsrareader

ALL_LIBS = \
	$(INT_LIBS) \
	$(EXT_LIBS)

include $(TOP)/build/Makefile.env

VPATH += $(OBJDIR)

#-------------------------------------------------------------------------------
# outer targets
#
vers-includes: $(addsuffix .vers.h,$(EXT_LIBS))

all std: makedirs vers-includes
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs vers-includes
	@ $(MAKE_CMD) $(ILIBDIR)/$@

$(EXT_LIBS): makedirs vers-includes
	@ $(MAKE_CMD) $(LIBDIR)/$@

.PHONY: vers-includes all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS)) \
	$(addprefix $(LIBDIR)/,$(EXT_LIBS))

.PHONY: $(TARGDIR)/all $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean
	@ rm -f $(LIBDIR)/libsra-schema.* $(LIBDIR)/libwsra-schema.*

.PHONY: clean

#-------------------------------------------------------------------------------
# tag
#
tag: \
	$(addsuffix _tag,$(ALL_LIBS))

.PHONY: tag $(addsuffix _tag,$(ALL_LIBS))


#-------------------------------------------------------------------------------
# srapath stub library
#
$(LIBDIR)/libsrapath: $(LIBDIR)/libsrapath.$(LIBX)

SRAPATH_SRC = \
	srapath-stub

SRAPATH_OBJ = \
	$(addsuffix .$(LOBX),$(SRAPATH_SRC))

$(LIBDIR)/libsrapath.$(LIBX): $(SRAPATH_OBJ)
	$(LD) --slib -o $@ $^

libsrapath.vers.h:
	@ true


#-------------------------------------------------------------------------------
# sradb embedded schema
#
$(LIBDIR)/libsraschema: $(LIBDIR)/libsraschema.$(LIBX)

$(LIBDIR)/libwsraschema: $(LIBDIR)/libwsraschema.$(LIBX)

sra-dflt-schema: sra-dflt-schema.$(OBJX)
	$(LD) --exe -o $@ $^ -skapp -svdb -skdb -skfg -skfs -sklib -ldl -sz -sbz2

sra-schema.c: sra-dflt-schema $(SRCDIR)/built-in.vschema $(TOP)/build/sra-dflt-schema.sh
	@ $(TOP)/build/sra-dflt-schema.sh $(OS) ./sra-dflt-schema -o$@ -I$(TOP)/interfaces -T$@.d $(SRCDIR)/built-in.vschema

SRA_SCHEMA_SRC = \
	sraschema \
	sra-schema

SRA_SCHEMA_OBJ = \
	$(addsuffix .$(LOBX),$(SRA_SCHEMA_SRC))

WSRA_SCHEMA_OBJ = \
	$(addsuffix .$(LOBX),$(SRA_SCHEMA_SRC))

SRA_SCHEMA_LIB = \
	-dvdb

WSRA_SCHEMA_LIB = \
	-dwvdb

$(LIBDIR)/libsra-schema.$(SHLX): $(SRA_SCHEMA_OBJ)
	$(LD) --dlib --vers $(SRCDIR) -o $@ $^ $(SRA_SCHEMA_LIB)

$(LIBDIR)/libwsra-schema.$(SHLX): $(WSRA_SCHEMA_OBJ)
	$(LD) --dlib --vers $(SRCDIR) -o $@ $^ $(WSRA_SCHEMA_LIB)

SRASCHEMA_SRC = \
	sraschema-stub

WSRASCHEMA_SRC = \
	wsraschema-stub

ifeq (--static,$(STATIC))
	SRASCHEMA_SRC += $(SRA_SCHEMA_SRC)
else
	SRASCHEMA_DEPS = $(LIBDIR)/libsra-schema.$(SHLX)
endif

ifeq (--static,$(STATIC))
	WSRASCHEMA_SRC += $(SRA_SCHEMA_SRC)
else
	WSRASCHEMA_DEPS = $(LIBDIR)/libwsra-schema.$(SHLX)
endif

SRASCHEMA_OBJ = \
	$(addsuffix .$(LOBX),$(SRASCHEMA_SRC))

WSRASCHEMA_OBJ = \
	$(addsuffix .$(LOBX),$(WSRASCHEMA_SRC))

$(LIBDIR)/libsraschema.$(LIBX): $(SRASCHEMA_OBJ) $(SRASCHEMA_DEPS)
	$(LD) --slib -o $@ $(SRASCHEMA_OBJ) $(SRA_SCHEMA_LIB)

$(LIBDIR)/libwsraschema.$(LIBX): $(WSRASCHEMA_OBJ) $(WSRASCHEMA_DEPS)
	$(LD) --slib -o $@ $(WSRASCHEMA_OBJ) $(WSRA_SCHEMA_LIB)

libsraschema_tag:
	@ $(TOP)/build/tag-module.sh $(MODULE) libsraschema $(SRASCHEMA_OBJ)


#-------------------------------------------------------------------------------
# sradb library
#
$(LIBDIR)/libsradb: $(addprefix $(LIBDIR)/libsradb.,$(LIBEXT))

SRADBCMN_SRC = \
	sramgr-cmn \
	sratbl-cmn \
	sracol \
	types

SRADB_SRC = \
	$(SRADBCMN_SRC) \
	sramgr \
	sratbl

SRADB_OBJ = \
	$(addsuffix .$(LOBX),$(SRADB_SRC))

SRADB_LIB = \
	-ssraschema \
	-ssrapath \
	-dvdb \
	-dkdb \
	-dkfs \
	-dklib

$(LIBDIR)/libsradb.$(SHLX): $(SRADB_OBJ)
	$(LD) --dlib --vers $(SRCDIR) -o $@ $^ $(SRADB_LIB)

$(LIBDIR)/libsradb.$(LIBX): $(SRADB_OBJ)
	$(LD) --slib --vers $(SRCDIR) -o $@ $^ $(SRADB_LIB)

libsradb_tag: $(SRADB_TAGS)
	@ $(TOP)/build/tag-module.sh $(MODULE) libsradb $(SRADB_OBJ)


#-------------------------------------------------------------------------------
# update version
#
$(LIBDIR)/libwsradb: $(addprefix $(LIBDIR)/libwsradb.,$(LIBEXT))

WSRADB_SRC = \
	$(SRADBCMN_SRC) \
	wsramgr \
	wsratbl

WSRADB_OBJ = \
	$(addsuffix .$(LOBX),$(WSRADB_SRC))

WSRADB_LIB = \
	-ssraschema \
	-ssrapath \
	-dwvdb \
	-dwkdb \
	-dkfs \
	-dklib

$(LIBDIR)/libwsradb.$(SHLX): $(WSRADB_OBJ)
	$(LD) --dlib --vers $(SRCDIR) -o $@ $^ $(WSRADB_LIB)

$(LIBDIR)/libwsradb.$(LIBX): $(WSRADB_OBJ)
	$(LD) --slib --vers $(SRCDIR) -o $@ $^ $(WSRADB_LIB)

libwsradb_tag: $(WSRADB_TAGS)
	@ $(TOP)/build/tag-module.sh $(MODULE) libwsradb $(WSRADB_OBJ)


#-------------------------------------------------------------------------------
# libsrareader
#
$(LIBDIR)/libsrareader: $(addprefix $(LIBDIR)/libsrareader.,$(LIBEXT))

SRAREADER_SRC = \
	reader-cmn \
	reader-fastq \
	reader-sff \
	reader-illumina \
	reader-abi

SRAREADER_OBJ = \
	$(addsuffix .$(LOBX),$(SRAREADER_SRC))

SRAREADER_LIB = \
	-dsradb \
	-dkdb \
	-dklib

$(LIBDIR)/libsrareader.$(SHLX): $(SRAREADER_OBJ)
	$(LD) --dlib --vers $(SRCDIR) -o $@ $^ $(SRAREADER_LIB)

$(LIBDIR)/libsrareader.$(LIBX): $(SRAREADER_OBJ)
	$(LD) --slib --vers $(SRCDIR) -o $@ $^ $(SRAREADER_LIB)

libsrareader_tag:
	@ $(TOP)/build/tag-module.sh $(MODULE) libsrareader $(SRAREADER_OBJ)

=== libs/sraxf/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: std

TOP ?= $(shell ../../build/abspath.sh ../..)
MODULE = libs/sraxf

MOD_LIBS = \
	libsraxf

WMOD_LIBS = \
	libwsraxf

ALL_LIBS = \
	$(MOD_LIBS) \
	$(WMOD_LIBS)

include $(TOP)/build/Makefile.env

#-------------------------------------------------------------------------------
# outer targets
#
vers-includes: $(addsuffix .vers.h,$(ALL_LIBS))

all std: makedirs vers-includes
	@ $(MAKE_CMD) $(TARGDIR)/std

$(ALL_LIBS): makedirs vers-includes
	@ $(MAKE_CMD) $(TARGDIR)/$@

.PHONY: vers-includes all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(TARGDIR)/,$(ALL_LIBS))

.PHONY: $(TARGDIR)/all $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# tag
#
tag: \
	$(addsuffix _tag,$(ALL_LIBS))

.PHONY: tag $(addsuffix _tag,$(ALL_LIBS))

#-------------------------------------------------------------------------------
# sra transform library
#
$(TARGDIR)/libsraxf: $(addprefix $(TARGDIR)/libsraxf.,$(MODEXT))

$(TARGDIR)/libsraxf.$(SHLX): $(MODDIR)/libsraxf.$(SHLX)

SRAXF_SRC = \
	untyped \
	v0-decompress-init \
	v0-decompress \
	v0-funcs \
	bio-start \
	dynamic-454-read-descriptor \
	format-spot-name \
	extract-name_coord \
	tokenize-spot_name-454 \
	tokenize-spot_name-illumina \
	tokenize-spot_name-abi \
	tokenize-spot_name-helicos \
	color-from-dna \
	dna-from-color \
	spot-desc \
	read-desc \
	rotate \
	swap \
	denormalize \
	normalize \
	qual4_decode \
	read-seg-from-readn \
	rewrite-spot-name \
	make-position \
	process-position \
	extract-coordinates \
	fpcodec \
	index_lookup

SRAXF_OBJ = \
	$(addsuffix .$(LOBX),$(SRAXF_SRC))

SRAXF_LIB = \
	-dksrch \
	-dvdb \
	-dkdb \
	-dklib \
	-dm \
	-dz

$(MODDIR)/libsraxf.$(SHLX): $(SRAXF_OBJ)
	$(LD) --dlib --vers $(SRCDIR) -o $@ $^ $(SRAXF_LIB)

$(TARGDIR)/libsraxf.$(LIBX): $(ILIBDIR)/libsraxf.$(LIBX)

$(ILIBDIR)/libsraxf.$(LIBX): $(SRAXF_OBJ)
	$(LD) --slib --vers $(SRCDIR) -o $@ $^ $(SRAXF_LIB)

libsraxf_tag:
	@ $(TOP)/build/tag-module.sh $(MODULE) libsraxf $(SRAXF_OBJ)


#-------------------------------------------------------------------------------
# sra transform update library
#
$(TARGDIR)/libwsraxf: $(addprefix $(TARGDIR)/libwsraxf.,$(MODEXT))

$(TARGDIR)/libwsraxf.$(SHLX): $(WMODDIR)/libwsraxf.$(SHLX)

WSRAXF_SRC = \
	$(SRAXF_SRC) \
	extract-name_fmt \
	extract-spot_name \
	extract-name_coord \
	tokenize-spot_name-454 \
	tokenize-spot_name-illumina \
	tokenize-spot_name-abi \
	tokenize-spot_name-helicos \
	stats \
	qual4_encode

WSRAXF_OBJ = \
	$(addsuffix .$(LOBX),$(WSRAXF_SRC))

WSRAXF_LIB = \
	-dwvdb \
	-dwkdb \
	-dksrch \
	-dklib \
	-dm \
	-dz

$(WMODDIR)/libwsraxf.$(SHLX): $(WSRAXF_OBJ)
	$(LD) --dlib --vers $(SRCDIR) -o $@ $^ $(WSRAXF_LIB)

$(TARGDIR)/libwsraxf.$(LIBX): $(ILIBDIR)/libwsraxf.$(LIBX)

$(ILIBDIR)/libwsraxf.$(LIBX): $(WSRAXF_OBJ)
	$(LD) --slib --vers $(SRCDIR) -o $@ $^ $(WSRAXF_LIB)

libswraxf_tag:
	@ $(TOP)/build/tag-module.sh $(MODULE) libwsraxf $(WSRAXF_OBJ)

=== libs/vdb/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: std

TOP ?= $(shell ../../build/abspath.sh ../..)
MODULE = libs/vdb

INT_LIBS = \

EXT_LIBS = \
	libvdb \
	libwvdb

ALL_LIBS = \
	$(INT_LIBS) \
	$(EXT_LIBS)

include $(TOP)/build/Makefile.env

#-------------------------------------------------------------------------------
# outer targets
#
vers-includes: $(addsuffix .vers.h,$(EXT_LIBS))

all std: makedirs vers-includes
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs vers-includes
	@ $(MAKE_CMD) $(ILIBDIR)/$@

$(EXT_LIBS): makedirs vers-includes
	@ $(MAKE_CMD) $(LIBDIR)/$@

.PHONY: vers-includes all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS)) \
	$(addprefix $(LIBDIR)/,$(EXT_LIBS))

.PHONY: $(TARGDIR)/all $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# tag
#
tag: \
	$(addsuffix _tag,$(ALL_LIBS))

.PHONY: tag $(addsuffix _tag,$(ALL_LIBS))

#-------------------------------------------------------------------------------
# virtual db library
#
$(LIBDIR)/libvdb: $(addprefix $(LIBDIR)/libvdb.,$(LIBEXT))

VDBCMN_SRC = \
	dbmgr-cmn \
	schema-tok \
	schema-parse \
	schema-type \
	schema-func \
	schema-prod \
	schema-expr \
	schema-eval \
	schema-tbl \
	schema-db \
	schema-dump \
	schema-int \
	schema \
	linker-int \
	linker-cmn \
	database-cmn \
	database-load \
	table-cmn \
	table-load \
	cursor-cmn \
	column-cmn \
	prod-cmn \
	prod-expr \
	prod-func \
	phys-cmn \
	phys-load \
	blob \
	blob-headers \
	page-map \
	row-id \
	row-len \
	fixed-row-len \
	merge \
	split \
	compare \
	meta-read \
	meta-value \
	meta-attr-read \
	cast \
	range-validate \
	parameter-read \
	redimension \
	index_project \
	index_lookup

VDB_SRC = \
	$(VDBCMN_SRC) \
	dbmgr \
	linker \
	database \
	table \
	cursor \
	column \
	prod \
	phys

VDB_OBJ = \
	$(addsuffix .$(LOBX),$(VDB_SRC))

VDB_LIB = \
	-dkdb \
	-dkfg \
	-dkfs \
	-dklib \
	-dz

$(LIBDIR)/libvdb.$(SHLX): $(VDB_OBJ)
	$(LD) --dlib --vers $(SRCDIR) -o $@ $^ $(VDB_LIB)

$(LIBDIR)/libvdb.$(LIBX): $(VDB_OBJ)
	$(LD) --slib --vers $(SRCDIR) -o $@ $^ $(VDB_LIB)

libvdb_tag: $(VDB_TAGS)
	@ $(TOP)/build/tag-module.sh $(MODULE) libvdb $(VDB_OBJ)

#-------------------------------------------------------------------------------
# update version
#
$(LIBDIR)/libwvdb: $(addprefix $(LIBDIR)/libwvdb.,$(LIBEXT))

WVDB_SRC = \
	$(VDBCMN_SRC) \
	wdbmgr \
	wlinker \
	wdatabase \
	wtable \
	wcursor \
	wcolumn \
	wprod \
	wphys \
	meta-write \
	meta-attr-write \
	meta-append \
	index_insert

WVDB_OBJ = \
	$(addsuffix .$(LOBX),$(WVDB_SRC))

WVDB_LIB = \
	-dwkdb \
	-dkfg \
	-dkfs \
	-dklib \
	-dz

$(LIBDIR)/libwvdb.$(SHLX): $(WVDB_OBJ)
	$(LD) --dlib --vers $(SRCDIR) -o $@ $^ $(WVDB_LIB)

$(LIBDIR)/libwvdb.$(LIBX): $(WVDB_OBJ)
	$(LD) --slib --vers $(SRCDIR) -o $@ $^ $(WVDB_LIB)

libwvdb_tag: $(WVDB_TAGS)
	@ $(TOP)/build/tag-module.sh $(MODULE) libwvdb $(WVDB_OBJ)

=== debian/changelog ===
sra-sdk (2.0.1-1) unstable; urgency=low

  * Initial release (Closes: #610603).

 -- Charles Plessy <plessy@debian.org>  Tue, 24 May 2011 14:48:10 +0900

=== debian/control ===
Source: sra-sdk
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Charles Plessy <plessy@debian.org>, Andreas Tille <tille@debian.org>
DM-Upload-Allowed: yes
Build-Depends: debhelper (>= 8),
 libbz2-dev,
 zlib1g-dev,
 libxml2-dev
Standards-Version: 3.9.2
Homepage: http://trace.ncbi.nlm.nih.gov/Traces/sra/sra.cgi?cmd=show&f=software&m=software&s=software
Vcs-Git: git://git.debian.org/debian-med/sra-sdk.git
Vcs-Browser: http://git.debian.org/?p=debian-med/sra-sdk.git;a=summary

Package: sra-toolkit
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: utilities for the NCBI Sequence Read Archive
 Tools for reading the SRA archive, generally by converting individual runs
 into some commonly used format such as fastq.
 .
 The textual dumpers "sra-dump" and "vdb-dump" are provided in this
 release as an aid in visual inspection. It is likely that their
 actual output formatting will be changed in the near future to a
 stricter, more formalized representation[s]. PLEASE DO NOT RELY UPON
 THE OUTPUT FORMAT SEEN IN THIS RELEASE.
 .
 The "help" information will be improved in near future releases, and
 the tool options will become standardized across the set. More documentation
 will also be provided documentation on the NCBI web site.
 .
 Tool options may change in the next release. Version 1 tool options
 will remain supported wherever possible in order to preserve
 operation of any existing scripts.

Package: sra-toolkit-libs0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Libraries for the SRA Toolkit
 This package provides all libraries and modules for executing the
 NCBI SRA toolkit's programs.  This currently includes:
 .
  libkdb                # physical layer reading library
  libkfg                # configuration library
  libkfs                # file system library
  libklib               # support library
  libkproc              # process synchronization library
  libkq                 # cross-thread queue library
  libksproc             # single-threaded emulation library
  libksrch              # search algorithm library
  libkxfs               # XML to filesystem library
  libkxml               # XML container support library
  libsra-schema         # weak-linked sra schema
  libsradb              # API for accessing sra
  libsrapath            # weak-link stubs for srapath
  libsrareader          # reader library
  libvdb                # virtual layer reading library
  libwkdb               # physical layer update library
  libwsradb             # update API for SRA
  libwvdb               # virtual layer update library

Package: sra-toolkit-libs-dev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Development files for the NCBI SRA Toolkit's libraries
 This package provides development support files for the
 NCBI SRA Toolkit's libraries.

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@

OUTDIR=$(CURDIR)/debian/tmp

override_dh_auto_configure:
	export OUTDIR=$(OUTDIR) ; make OUTDIR=$(OUTDIR) out ; make dynamic

override_dh_auto_build:
	export LD_LIBRARY_PATH="$$LD_LIBRARY_PATH:$(OUTDIR)/lib"; export OUTDIR=$(OUTDIR) ; make

override_dh_auto_test:

override_dh_prep:
	dh_prep -X debian/tmp

# Remove empty library from /usr/bin
override_dh_install:
	dh_install
	rmdir $(CURDIR)/debian/sra-toolkit/usr/bin/ncbi

# Temporary correction as long as libsra-schema is weak-linked.
override_dh_link:
	mv $(CURDIR)/debian/sra-toolkit-libs-dev/usr/lib/libsra-schema.so $(CURDIR)/debian/sra-toolkit-libs0/usr/lib/
	dh_link

=== debian/watch ===
version=3
http://trace.ncbi.nlm.nih.gov/Traces/sra/sra.cgi?cmd=show&f=software&m=software&s=software static/sra_sdk-(.*).tar.gz
